unit ExeWatch;

interface

uses
    Windows, SysUtils, Classes, IniFiles, dllhook;

type
    //---------------------------------------------------------------
    //  f[^
    TExeData = record
        Path: string;
        LastBoot: TDateTime;
        BootCount: Cardinal;
    end;

    //---------------------------------------------------------------
    //  EBhEnhjێ
    TRecentApps = class;
    TProcIdHolder = class
    private
        FHwnd: HWND;
        FProcId: Cardinal;
        FCaller: TRecentApps;
        FTickCount: Cardinal;
        FDateTime: TDateTime;
        FPath: string;
    public
        constructor Create(const WH: HWND; const ProcId: Cardinal; const Path: string;
                            const Caller: TRecentApps);
        destructor Destroy(); override;
        function TickCount(): Cardinal;
        function Check(): Boolean;
    end;

    //---------------------------------------------------------------
    //  EBhE̐ƔjDLLɒʒmĂ炤
    TRecentApps = class(TCbtHookReciever)
    private
        FProcIdHolders: TStringList;
        FRecentApps: TMemIniFile;
    protected
        procedure DoTargetCreate(WH: HWND); override;
        procedure DoTargetDestroy(WH: HWND); override;
    public
        constructor Create();
        destructor Destroy; override;
        procedure Put(ProcIdHolder: TProcIdHolder);
        procedure Check();
        procedure SnapShot(Target: TMemIniFile);
    public
        property RecentApps: TMemIniFile read FRecentApps;
    end;

const
    EXEPROP_LASTBOOT  = 'LastBoot';
    EXEPROP_BOOTCOUNT = 'BootCount';
    EXEPROP_VERSION   = 'FileVersion';
    EXEPROP_DESCRIPT  = 'FileDescription';
var
    RecentApps: TRecentApps = nil;

implementation

//==============================================================================
//  UTILITY
//==============================================================================


//------------------------------------------------------------------------------
//  \[Xɂo[W擾
//  http://www2.odn.ne.jp/~cag07740/tech_info/delphi_ans5.html
//  http://hp.vector.co.jp/authors/VA026252/tips/delphi_version.html
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0226.txt
const
    FVERREQ_Comments = 'Comments';
    FVERREQ_CompanyName = 'CompanyName';
    FVERREQ_FileDescription = 'FileDescription';
    FVERREQ_FileVersion = 'FileVersion';
    FVERREQ_InternalName = 'InternalName';
    FVERREQ_LegalCopyright = 'LegalCopyright';
    FVERREQ_LegalTrademarks = 'LegalTrademarks';
    FVERREQ_OriginalFilename = 'OriginalFilename';
    FVERREQ_PrivateBuild = 'PrivateBuild';
    FVERREQ_ProductName = 'ProductName';
    FVERREQ_ProductVersion = 'ProductVersion';
    FVERREQ_SpecialBuild = 'SpecialBuild';

//------------------------------------------------------------------------------
// o[W擾
function GetVersionInfo(const Request, Path: string): string;
const
    Translation = '\VarFileInfo\Translation';
    FileInfo = '\StringFileInfo\%0.4s%0.4s\';
var
    BufSize, HWnd: DWORD;
    VerInfoBuf: Pointer;
    VerData: Pointer;
    VerDataLen: Longword;
    PathLocale: String;
begin
    // Kvȃobt@̃TCY擾
    BufSize := GetFileVersionInfoSize(PChar(Path), HWnd);
    if BufSize <> 0 then
    begin
        // m
        GetMem(VerInfoBuf, BufSize);
        try
            GetFileVersionInfo(PChar(Path), 0, BufSize, VerInfoBuf);
            // ϐubN̕ϊe[uw
            VerQueryValue(VerInfoBuf, PChar(Translation), VerData, VerDataLen);
            if (VerDataLen > 0) then
            begin
                // 8̂PUiɕϊ
                // '\StringFileInfo\027382\FileDescription'
                PathLocale := Format(FileInfo + Request,
                                [IntToHex(Integer(VerData^) and $FFFF, 4),
                                IntToHex((Integer(VerData^) shr 16) and $FFFF, 4)]);
                VerQueryValue(VerInfoBuf, PChar(PathLocale), VerData, VerDataLen);
                if VerDataLen > 0 then
                begin
                    // VerData̓[ŏI镶ł͂ȂƂɒ
                    result := '';
                    SetLength(result, VerDataLen);
                    StrLCopy(PChar(result), VerData, VerDataLen);
                    Result := Trim(Result);
                end;
            end;
        finally
            // 
            FreeMem(VerInfoBuf);
        end;
    end;
end;

//==============================================================================
//  THwndHolder
//==============================================================================

//------------------------------------------------------------------------------
//  RXgN^
constructor TProcIdHolder.Create(const WH: HWND; const ProcId: Cardinal; const Path: string;
                const Caller: TRecentApps);
begin
    //  nꂽEBhEnh
    FHwnd := WH;
    FProcId := ProcId;
    //  Ňoߎ
    FTickCount := GetTickCount();
    //  ݎ
    FDateTime := Now();
    //  EBhEnh̎̃pX
    FPath := Path;
    //  ŌɌĂяo
    FCaller := Caller;
end;

//------------------------------------------------------------------------------
//  fXgN^
destructor TProcIdHolder.Destroy();
begin
    FCaller.Put(Self);
end;

//------------------------------------------------------------------------------
//  
function TProcIdHolder.TickCount(): Cardinal;
begin
    Result := GetTickCount() - FTickCount;
end;

//------------------------------------------------------------------------------
//  mȂԂ̃EBhEj
function TProcIdHolder.Check(): Boolean;
begin
    Result := IsWindow(FHwnd);
end;

//==============================================================================
//  TRecentApps
//==============================================================================

//------------------------------------------------------------------------------
//  RXgN^
constructor TRecentApps.Create();
begin
    inherited Create;
    //  f[^ǂݍ
    FRecentApps := TMemIniFile.Create(ChangeFileExt(ParamStr(0), '.dat'));
    FProcIdHolders := TStringList.Create();
    FProcIdHolders.Sorted := True;
end;

//------------------------------------------------------------------------------
//  fXgN^
destructor TRecentApps.Destroy();
begin
    Self.Stop();

    while (FProcIdHolders.Count > 0) do
    begin
        FProcIdHolders.Objects[0].Free();
        FProcIdHolders.Delete(0);
    end;
    FProcIdHolders.Free;

    //  f[^
    FRecentApps.UpdateFile();
    FRecentApps.Free();
    //  ͂낵
    inherited;
end;

//------------------------------------------------------------------------------
//  EXEǉ
procedure TRecentApps.Put(ProcIdHolder: TProcIdHolder);
var
    ExeData: TExeData;
begin
    //  ǂݏo
    ExeData.Path      := ProcIdHolder.FPath;
    ExeData.LastBoot  := FRecentApps.ReadDateTime(ExeData.Path, EXEPROP_LASTBOOT, Now());
    ExeData.BootCount := FRecentApps.ReadInteger(ExeData.Path, EXEPROP_BOOTCOUNT, 0);

    //  C
    if (ExeData.LastBoot < ProcIdHolder.FDateTime) then
    begin
        ExeData.LastBoot := ProcIdHolder.FDateTime;
    end;
    ExeData.BootCount := ExeData.BootCount + 1;

    //  ߂
    FRecentApps.WriteDateTime(ExeData.Path, EXEPROP_LASTBOOT, ExeData.LastBoot);
    FRecentApps.WriteInteger(ExeData.Path, EXEPROP_BOOTCOUNT, ExeData.BootCount);
    FRecentApps.WriteString(ExeData.Path, EXEPROP_VERSION, GetVersionInfo(FVERREQ_FileVersion, ExeData.Path));
    FRecentApps.WriteString(ExeData.Path, EXEPROP_DESCRIPT, GetVersionInfo(FVERREQ_FileDescription, ExeData.Path));

    //  t@CXV
    //FRecentApps.UpdateFile();
end;

//------------------------------------------------------------------------------
//  f[^`FbN
procedure TRecentApps.Check();
var
    i: integer;
    T: TProcIdHolder;
    StrBuf: TStrings;
begin
    //  ̊ԂɂEBhEł肵ȂˁH
    for i := FProcIdHolders.Count - 1 downto 0 do
    begin
        T := TProcIdHolder(FProcIdHolders.Objects[i]);
        if (not T.Check()) then
        begin
            T.Free();
            FProcIdHolders.Delete(i);
        end;
    end;

    //  ̊Ԃɂt@CȂȂ肵ĂȂH
    try
        StrBuf := TStringList.Create();
        try
            FRecentApps.ReadSections(StrBuf);
            for i := 0 to StrBuf.Count - 1 do
            begin
                if (not FileExists(StrBuf[i])) then
                begin
                    FRecentApps.EraseSection(StrBuf[i]);
                end;
            end;
            //  t@CXV
            FRecentApps.UpdateFile();
        finally
            StrBuf.Free();
        end;
    except
        ;
    end;
end;

//------------------------------------------------------------------------------
//  Or
var
    PRE_PROCESS_ID: Cardinal = 0;

//------------------------------------------------------------------------------
//  EBhEꂽ
procedure TRecentApps.DoTargetCreate(WH: HWND);
var
    Path: string;
    ProcID: Cardinal;
    StrID: string;
    Dummy: integer;
begin
    //  LĂȂ
    if (GetWindow(WH, GW_OWNER) <> 0) then Exit;

    //  ŏʂ̃EBhEȂ
    if GetMostTopLevelWindow(WH) <> WH then Exit;

    //  ̃EBhẼvZXID́H
    GetWindowThreadProcessId(WH, @ProcID);

    //  ̓z͂ǂH
    if (ProcID = PRE_PROCESS_ID) then Exit;

    //  oĂ
    PRE_PROCESS_ID := ProcID;

    //  ƂĊǗ
    StrID := IntToStr(ProcID);

    //  ɓo^ς݂̃vZXł͂Ȃ
    if (FProcIdHolders.Find(StrID, Dummy)) then Exit;

    //  IbP[
    Path := GetPathFromWindowHandle(WH);
    if (Path <> '') then
    begin
        //  gł͂ȂH
        if (Path = ParamStr(0)) then Exit;

        //  oĂĂ낤
        FProcIdHolders.AddObject(StrID, TProcIdHolder.Create(WH, ProcID, Path, Self));
    end;
    inherited DoTargetCreate(WH);
end;

//------------------------------------------------------------------------------
//  EBhÊĂꂽ
procedure TRecentApps.DoTargetDestroy(WH: HWND);
var
    index: integer;
    ProcID: Cardinal;
    StrID: string;
begin
    //  ̃EBhẼvZXID́H
    GetWindowThreadProcessId(WH, @ProcID);

    //  ƂĊǗ
    StrID := IntToStr(ProcID);

    //  NmĂ邩H
    if (FProcIdHolders.Find(StrID, index)) then
    begin
        TProcIdHolder(FProcIdHolders.Objects[index]).Free;
        FProcIdHolders.Delete(index);
        inherited DoTargetDestroy(WH);
    end;
end;

//------------------------------------------------------------------------------
//  \̂߂̃XibvVbg
procedure TRecentApps.SnapShot(Target: TMemIniFile);
var
    StrBuf: TStrings;
begin
    try
        StrBuf := TStringList.Create();
        try
            Check();
            FRecentApps.GetStrings(StrBuf);
            Target.SetStrings(StrBuf);
        finally
            StrBuf.Free();
        end;
    except
        ;
    end;
end;

end.

